;
;******************************************************************************
;
; ----------------------------Support procedures------------------------------ 
;
;******************************************************************************
;
pro xmksed_cleanup,base

widget_control, base, GET_UVALUE = state, /NO_COPY
if n_elements(state) ne 0 then begin

endif

state = 0B

end
;
;******************************************************************************
;
pro xmksed_connect,state

lwave = min(state.p.reg[0,*],max=rwave)

mctabinv,(*state.d.espec)[*,0],lwave,idx
lidx = total(idx)

mctabinv,(*state.d.espec)[*,0],rwave,idx
ridx = total(idx)

disp = ((*state.d.espec)[lidx,0]-(*state.d.espec)[lidx-10,0]) / 10. 
nx   = floor( ((*state.d.espec)[ridx,0]-(*state.d.espec)[lidx,0])/disp)

newwave = (findgen(nx)+1) * disp + (*state.d.espec)[lidx,0]
z = where(newwave lt (*state.d.espec)[ridx,0],count)
if count ne 0 then newwave = newwave[z]

m = ((*state.d.espec)[ridx,1]-(*state.d.espec)[lidx,1]) / $
    ((*state.d.espec)[ridx,0]-(*state.d.espec)[lidx,0])

b = (*state.d.espec)[lidx,1]-m*(*state.d.espec)[lidx,0]

newflux = poly(newwave,[b,m])
newerror = fltarr(n_elements(newwave))+!values.f_nan

*state.d.pspec = [[(*state.d.espec)[0:lidx,0],$
                   newwave,(*state.d.espec)[ridx:*,0]],$
                  [(*state.d.espec)[0:lidx,1],$
                   newflux,(*state.d.espec)[ridx:*,1]],$
                  [(*state.d.espec)[0:lidx,2],$
                   newerror,(*state.d.espec)[ridx:*,1]]]


state.r.cursormode = 'None'
xmksed_plotupdate,state

end
;
;******************************************************************************
;
pro xmksed_loadspec,state

;  Get files.

path = cfld(state.w.path_fld,7,CANCEL=cancel)
if cancel then return

specfile = cfld(state.w.ispectrum_fld,7,/EMPTY,CANCEL=cancel)
if cancel then return
specfile = cfile(path+specfile,WIDGET_ID=state.w.xmksed_base,$
                 CANCEL=cancel)
if cancel then return

;  Read standard spectra.

readspec,specfile,spc,hdr,obsmode,start,stop,norders,naps,orders,$
  xunits,yunits,slith_pix,slith_arc,slitw_pix,slitw_arc,airmass

;  Save info

*state.d.espec = spc
*state.d.ospec = spc
*state.d.pspec = spc
*state.d.hdr   = hdr          
state.p.xunits = xunits
state.p.yunits = yunits

state.p.plot1absxrange = [0,max(spc[*,0],/NAN)]
state.p.plot1absyrange = [0,max(spc[*,1],/NAN)]
state.p.plot1xrange = state.p.plot1absxrange
state.p.plot1yrange = state.p.plot1absyrange

xmksed_plotupdate,state
xmksed_setminmax,state

end
;
;******************************************************************************
;
pro xmksed_long,state,x,y






end
;
;******************************************************************************
;
pro xmksed_plotspec,state

xtitle ='!5Wavelength ('+strtrim(state.p.xunits,2)+')'
ytitle ='!5Flux ('+strtrim(state.p.yunits,2)+')'

z = where(finite((*state.d.pspec)[*,0]) eq 1)

plot,(*state.d.pspec)[z,0],(*state.d.pspec)[z,1],psym=10,/xsty,/ysty,$
  xrange=state.p.plot1xrange,yrange=state.p.plot1yrange,xtitle=xtitle,$
  ytitle=ytitle

state.p.pscale1 = !p
state.p.xscale1 = !x
state.p.yscale1 = !y



end
;
;******************************************************************************
;
pro xmksed_short,state,x,y

mctabinv,(*state.d.espec)[*,0],x,idx
idx = total(idx)

disp = ((*state.d.espec)[idx+10,0]-(*state.d.espec)[idx,0]) / 10. 
nx   = floor((*state.d.espec)[idx,0]/disp)

newwave = (findgen(nx)-(nx) ) * disp + (*state.d.espec)[idx,0]

z = where(newwave gt 0.0)
newwave = [0.0,newwave[z]]

coeff   = [0.,(*state.d.espec)[idx,1]/(*state.d.espec)[idx,0]]
newflux = poly(newwave,coeff)

*state.d.pspec = [[newwave,(*state.d.espec)[idx:*,0]],$
                  [newflux,(*state.d.espec)[idx:*,1]]]

state.r.cursormode = 'None'
xmksed_plotupdate,state

end
;
;******************************************************************************
;
pro xmksed_plotupdate,state

wset, state.p.pixmap1_wid
erase
xmksed_plotspec,state

wset, state.p.plotwin1_wid
device, copy=[0,0,state.p.plot1size[0],state.p.plot1size[1],0,0,$
              state.p.pixmap1_wid]

end
;
;******************************************************************************
;
pro xmksed_setminmax,state

widget_control, state.w.xmin_fld[1],SET_VAL=strtrim(state.p.plot1xrange[0],2)
widget_control, state.w.xmax_fld[1],SET_VAL=strtrim(state.p.plot1xrange[1],2)
widget_control, state.w.ymin1_fld[1],SET_VAL=strtrim(state.p.plot1yrange[0],2)
widget_control, state.w.ymax1_fld[1],SET_VAL=strtrim(state.p.plot1yrange[1],2)

end
;
;******************************************************************************
;
pro xmksed_writefile,state

file = cfld(state.w.oname_fld,7,/EMPTY,CANCEL=cancel)
if cancel then return

writefits,file+'.fits',*state.d.espec,*state.d.hdr

end
;
;******************************************************************************
;
pro xmksed_zoom,state,IN=in,OUT=out

delabsx = state.p.plot1absxrange[1]-state.p.plot1absxrange[0]
delx    = state.p.plot1xrange[1]-state.p.plot1xrange[0]

delabsy = state.p.plot1absyrange[1]-state.p.plot1absyrange[0]
dely    = state.p.plot1yrange[1]-state.p.plot1yrange[0]

xcen = state.p.plot1xrange[0]+delx/2.
ycen = state.p.plot1yrange[0]+dely/2.

case state.r.cursormode of 

    'XZoom': begin

        z = alog10(delabsx/delx)/alog10(2)
        if keyword_set(IN) then z = z+1 else z=z-1
        hwin = delabsx/2.^z/2.
        state.p.plot1xrange = [xcen-hwin,xcen+hwin]
        xmksed_plotupdate,state

    end

    'YZoom': begin

        z = alog10(delabsy/dely)/alog10(2)
        if keyword_set(IN) then z = z+1 else z=z-1
        hwin = delabsy/2.^z/2.
        state.p.plot1yrange = [ycen-hwin,ycen+hwin]
        xmksed_plotupdate,state

    end

    'Zoom': begin

        z = alog10(delabsx/delx)/alog10(2)
        if keyword_set(IN) then z = z+1 else z=z-1
        hwin = delabsx/2.^z/2.
        state.p.plot1xrange = [xcen-hwin,xcen+hwin]

        z = alog10(delabsy/dely)/alog10(2)
        if keyword_set(IN) then z = z+1 else z=z-1
        hwin = delabsy/2.^z/2.
        state.p.plot1yrange = [ycen-hwin,ycen+hwin]

        xmksed_plotupdate,state

    end

    else:

endcase

end
;
;******************************************************************************
;
; ------------------------------Event Handlers-------------------------------- 
;
;******************************************************************************
;
pro xmksed_event, event

widget_control, event.top, GET_UVALUE = state, /NO_COPY
widget_control, event.id,  GET_UVALUE = uvalue

case uvalue of

    'Fix Type': begin

        case event.index of 

            0: state.r.fixmode = 'Short'
            1: state.r.fixmode = 'Connect'
            2: state.r.fixmode = 'Long'

        endcase

    end

    'Input Spectrum': begin
        
        path = cfld(state.w.path_fld,7,CANCEL=cancel)
        if cancel then return
        if path ne '' then path = cpath(path,$
                                        WIDGET_ID=state.w.xmksed_base,$
                                        CANCEL=cancel)
        if cancel then return
        obj = dialog_pickfile(DIALOG_PARENT=state.w.xmksed_base,$
                              PATH=path,/MUST_EXIST,FILTER='*.fits')
        if obj eq '' then goto, cont
        widget_control,state.w.ispectrum_fld[1], $
          SET_VALUE = strmid(obj[0],strpos(obj,'/',/REVERSE_S)+1)
        
    end

    'Keyboard': begin
        
        case strtrim(event.ch,2) of 
            
            'c': begin
                
                state.r.cursormode = 'None'
                state.p.reg[*] = !values.f_nan
                xmksed_plotupdate,state
                
            end

            'e': state.r.cursormode = state.r.fixmode

            'i': xmksed_zoom,state,/IN

            'o': xmksed_zoom,state,/OUT

            
            's': *state.d.espec = *state.d.pspec

            'u': begin ; Undo

                *state.d.pspec = *state.d.espec
                state.p.reg[*] = !values.f_nan
                xmksed_plotupdate,state

            end
            
            'w': begin

                state.p.plot1xrange = state.p.plot1absxrange
                state.p.plot1yrange = state.p.plot1absyrange                
                xmksed_plotupdate,state
                xmksed_setminmax,state
                
            end
            
            'x': begin 

                if state.r.cursormode eq 'None' then begin

                    state.r.cursormode = 'XZoom'
                    state.p.reg[*] = !values.f_nan
                    
                endif

            end

            'y': begin 

                if state.r.cursormode eq 'None' then begin

                    state.r.cursormode = 'YZoom'
                    state.p.reg[*] = !values.f_nan
                    
                endif

            end

            'z': begin
                
                state.r.cursormode = 'Zoom'
                state.p.reg[*] = !values.f_nan
                
            end
            
            else:
            
        endcase
        
    end

    'Load Spectrum': xmksed_loadspec,state

    'Output Format': begin

        if event.value eq 'Text' then state.r.textoutput=event.select
        if event.value eq 'FITS' then state.r.fitsoutput=event.select
        
    end

    'Path Button': begin
        
        path= dialog_pickfile(/DIRECTOR,$
                              DIALOG_PARENT=state.w.xmksed_base,$
                              TITLE='Select Path',/MUST_EXIST)

        if path ne '' then begin
            
            path = cpath(path,WIDGET_ID=state.w.xmksed_base,$
                         CANCEL=cancel)
            if cancel then return
            widget_control,state.w.path_fld[1],SET_VALUE = path
            setfocus,state.w.path_fld

        endif
    end

    'Quit': begin
        
        widget_control, event.top, /DESTROY
        goto, getout
        
    end

    'Write File': xmksed_writefile,state

endcase

cont: 

widget_control, state.w.xmksed_base, SET_UVALUE=state, /NO_COPY
getout:

end
;
;******************************************************************************
;
pro xmksed_minmax,event

widget_control, event.top, GET_UVALUE = state, /NO_COPY
widget_control, event.id,  GET_UVALUE = uvalue

case uvalue of 

    'X Min': begin

        xmin = cfld(state.w.xmin_fld,4,/EMPTY,CANCEL=cancel)
        if cancel then return
        xmin2 = crange(xmin,state.p.plot1xrange[1],'X Min',/KLT,$
                       WIDGET_ID=state.w.xmksed_base,CANCEL=cancel)
        if cancel then begin
            
            widget_control, state.w.xmin_fld[0],set_value=state.p.plotxrange[0]
            return
            
        endif else state.p.plot1xrange[0] = xmin2

    end
    'X Max': begin

        xmax = cfld(state.w.xmax_fld,4,/EMPTY,CANCEL=cancel)
        if cancel then return
        xmax2 = crange(xmax,state.p.plot1xrange[0],'X Max',/KGT,$
                       WIDGET_ID=state.w.xmksed_base,CANCEL=cancel)
        if cancel then begin
            
            widget_control, state.w.xmax_fld[0],set_value=state.p.plotxrange[1]
            return
            
        endif else state.p.plot1xrange[1] = xmax2

    end
    'Y1 Min': begin

        ymin = cfld(state.w.ymin1_fld,4,/EMPTY,CANCEL=cancel)
        if cancel then return
        ymin2 = crange(ymin,state.p.plot1yrange[1],'Y Min',/KLT,$
                       WIDGET_ID=state.w.xmksed_base,CANCEL=cancel)
        if cancel then begin
            
            widget_control,state.w.ymin1_fld[0],set_val=state.p.plot1yrange[0]
            return
            
        endif else state.p.plot1yrange[0] = ymin2
        
    end
    'Y1 Max': begin

        ymax = cfld(state.w.ymax1_fld,4,/EMPTY,CANCEL=cancel)
        if cancel then return
        ymax2 = crange(ymax,state.p.plot1yrange[0],'Y Max',/KGT,$
                       WIDGET_ID=state.w.xmksed_base,CANCEL=cancel)
        if cancel then begin
            
            widget_control,state.w.ymax1_fld[0],set_val=state.p.plot1yrange[1]
            return
            
        endif else state.p.plot1yrange[1] = ymax2
        
    end
    
endcase

xmksed_plotupdate,state

widget_control, state.w.xmksed_base, SET_UVALUE=state, /NO_COPY

end
;
;******************************************************************************
;
pro xmksed_plotwinevent1, event

widget_control, event.top, GET_UVALUE = state, /NO_COPY
widget_control, event.id,  GET_UVALUE = uvalue

;  Check to see if it is a TRACKING event.

if strtrim(tag_names(event,/STRUCTURE_NAME),2) eq 'WIDGET_TRACKING' then begin

    if event.enter eq 0 then widget_control, state.w.keyboard, SENSITIVE=0
    wset, state.p.plotwin1_wid
    device, copy=[0,0,state.p.plot1size[0],state.p.plot1size[1],0,0,$
                  state.p.pixmap1_wid]
    goto, cont

endif

 ;  If not, set the keyboard focus and active window.

widget_control, state.w.keyboard, /INPUT_FOCUS, /SENSITIVE

!p = state.p.pscale1
!x = state.p.xscale1
!y = state.p.yscale1
x  = event.x/float(state.p.plot1size[0])
y  = event.y/float(state.p.plot1size[1])
xy = convert_coord(x,y,/NORMAL,/TO_DATA)

if event.type eq 1 then begin

    case state.r.cursormode of 

        'Short': xmksed_short,state,xy[0],xy[1]

        'Connect': begin

            z = where(finite(state.p.reg) eq 1,count)
            if count eq 0 then begin

                state.p.reg[*,0] = xy[0:1]
                mctabinv,(*state.d.espec)[*,0],xy[0],idx
                idx = total(idx)

                wset, state.p.pixmap1_wid
                plots, [xy[0],xy[0]],[(*state.d.espec)[idx,1],$
                                      (*state.d.espec)[idx,1]],color=3,psym=2
                wset, state.p.plotwin1_wid
                device, copy=[0,0,state.p.plot1size[0],state.p.plot1size[1],0,$
                              0,state.p.pixmap1_wid]

            endif else begin

                state.p.reg[*,1] = xy[0:1]
                xmksed_connect,state

            endelse


        end

        'Long': xmksed_long,state,xy[0],xy[1]

        'XZoom': begin

            z = where(finite(state.p.reg) eq 1,count)
            if count eq 0 then begin
                
                state.p.reg[*,0] = xy[0:1]
                wset, state.p.pixmap1_wid
                plots, [event.x,event.x],[0,state.p.plot1size[1]],color=2,$
                  /DEVICE,linestyle=1,thick=2
                wset, state.p.plotwin1_wid
                device, copy=[0,0,state.p.plot1size[0],state.p.plot1size[1],0,$
                              0,state.p.pixmap1_wid]
               
            endif else begin

                state.p.reg[*,1] = xy[0:1]
                state.p.plot1xrange = [min(state.p.reg[0,*],max=m),m]
                state.r.cursormode = 'None'
                state.p.reg[*] = !values.f_nan
                xmksed_plotupdate,state
                xmksed_setminmax,state
                
            endelse


        end

        'YZoom': begin

            z = where(finite(state.p.reg) eq 1,count)
            if count eq 0 then begin
                
                state.p.reg[*,0] = xy[0:1]
                wset, state.p.pixmap1_wid
                plots, [0,state.p.plot1size[0]],[event.y,event.y],color=2,$
                  /DEVICE,linestyle=1,thick=2

                wset, state.p.plotwin1_wid
                device, copy=[0,0,state.p.plot1size[0],state.p.plot1size[1],0,$
                              0,state.p.pixmap1_wid]
               
            endif else begin

                state.p.reg[*,1] = xy[0:1]
                state.p.plot1yrange = [min(state.p.reg[1,*],max=m),m]
                state.r.cursormode = 'None'
                state.p.reg[*] = !values.f_nan
                xmksed_plotupdate,state
                xmksed_setminmax,state
                
            endelse

        end
        
        'Zoom': begin
            
            z = where(finite(state.p.reg) eq 1,count)
            if count eq 0 then state.p.reg[*,0] = xy[0:1] else begin 
                
                state.p.reg[*,1] = xy[0:1]
                state.p.plot1xrange = [min(state.p.reg[0,*],max=max),max]
                state.p.plot1yrange = [min(state.p.reg[1,*],max=max),max]
                xmksed_plotupdate,state
                xmksed_setminmax,state
                state.r.cursormode = 'None'
                state.p.reg[*] = !values.f_nan
                
            endelse
            
        end
        
        else:
        
    endcase
    
endif

;  Copy the pixmaps and draw the lines.


wset, state.p.plotwin1_wid
device, copy=[0,0,state.p.plot1size[0],state.p.plot1size[1],0,0,$
              state.p.pixmap1_wid]

wset, state.p.plotwin1_wid

case state.r.cursormode of 

    'XZoom': begin

        wset, state.p.plotwin1_wid
        plots, [event.x,event.x],[0,state.p.plot1size[1]],color=2,/DEVICE

    end

    'YZoom': plots, [0,state.p.plot1size[0]],[event.y,event.y],color=2,/DEVICE

    'Zoom': begin

        plots, [event.x,event.x],[0,state.p.plot1size[1]],color=2,/DEVICE
        plots, [0,state.p.plot1size[0]],[event.y,event.y],color=2,/DEVICE
        xy = convert_coord(event.x,event.y,/DEVICE,/TO_DATA)
        plots,[state.p.reg[0,0],state.p.reg[0,0]],[state.p.reg[1,0],xy[1]],$
          linestyle=2,color=2
        plots, [state.p.reg[0,0],xy[0]],[state.p.reg[1,0],state.p.reg[1,0]],$
          linestyle=2,color=2
        
    end

    else: begin

        plots, [event.x,event.x],[0,state.p.plot1size[1]],color=2,/DEVICE
        plots, [0,state.p.plot1size[0]],[event.y,event.y],color=2,/DEVICE

    end

endcase

;  Update the cursor tracking

label = 'Cursor X: '+strtrim(xy[0],2)
widget_control,state.w.message,set_value=label

cont:

widget_control, state.w.xmksed_base, SET_UVALUE=state, /NO_COPY
    
end
;
;******************************************************************************
;
pro xmksed_resize, event

widget_control, event.top, GET_UVALUE = state, /NO_COPY
widget_control, event.id,  GET_UVALUE = uvalue

widget_control, state.w.xmksed_base, tlb_get_size = size

;  Window 1

state.p.plot1size[0]=size[0]-state.p.buffer[0]
state.p.plot1size[1]=size[1]-state.p.buffer[1]

widget_control, state.w.plotwin1, draw_xsize=state.p.plot1size[0]
widget_control, state.w.plotwin1, draw_ysize=state.p.plot1size[1]

wdelete,state.p.pixmap1_wid
window, /free, /pixmap,xsize=state.p.plot1size[0],ysize=state.p.plot1size[1]
state.p.pixmap1_wid = !d.window

wset, state.p.plotwin1_wid
device, copy=[0,0,state.p.plot1size[0],state.p.plot1size[1],0,0,$
              state.p.pixmap1_wid]

xmksed_plotupdate,state

widget_control, state.w.xmksed_base, SET_UVALUE=state, /NO_COPY

end
;
;******************************************************************************
;
; ------------------------------Main Program-------------------------------- 
;
;******************************************************************************
;
pro xmksed

if xregistered('xmksed') then goto, cont

;  Build three structures which will hold important info.
;  w - contains info pertaining to widget operations.
;  r - contains info pertaining to the reduction process.
;  d - contains all of the data.

w = {message:0L,$
     keyboard:0L,$
     ispectrum_fld:[0L,0L],$
     oname_fld:[0L,0L],$
     path_fld:[0L,0L],$
     plotwin1:0,$
     plotwin2:0,$
     xmksed_base:0L,$
     xmin_fld:[0L,0L],$
     xmax_fld:[0L,0L],$
     ymin1_fld:[0L,0L],$
     ymax1_fld:[0L,0L]}

r = {cursormode:'None',$
     fitsoutput:1,$
     fixmode:'Short',$
     textoutput:0}

d = {hdr:ptr_new(strarr(2)),$
     espec:ptr_new(fltarr(2)),$
     ospec:ptr_new(fltarr(2)),$
     pspec:ptr_new(fltarr(2))}

p = {activespec:1,$
     buffer:[0.,0.],$
     pixmap1_wid:0L,$
     plotwin1_wid:0L,$
     plot1absxrange:[0.,0.],$
     plot1absyrange:[0.,0.],$
     plot1xrange:[0.,0.],$
     plot1yrange:[0.,0.],$
     plot1size:[670,400],$
     pscale1:!p,$
     xscale1:!x,$
     xunits:'',$
     yscale1:!y,$
     yunits:'',$
     reg:[[!values.f_nan,!values.f_nan],$
          [!values.f_nan,!values.f_nan]]}


;  Load the three structures in the state structure.

state = {w:w,r:r,d:d,p:p}

;  Build the widget.

buttonfont = '-adobe-helvetica-bold-r-normal--14-140-75-75-p-82-iso8859-1'
textfont   = '-adobe-helvetica-medium-r-normal--0-0-75-75-p-0-iso8859-1'
    
state.w.xmksed_base = widget_base(title='Xmksed', $
                                  /COLUMN,$
                                  /TLB_SIZE_EVENTS)

   quit_button = widget_button(state.w.xmksed_base,$
                               FONT=buttonfont,$
                               EVENT_PRO='xmksed_event',$
                               VALUE='Quit',$
                               UVALUE='Quit')


   state.w.keyboard = widget_text(state.w.xmksed_base, $
                                  /ALL_EVENTS, $
                                  SCR_XSIZE=1, $
                                  SCR_YSIZE=1, $
                                  UVALUE='Keyboard', $
                                  EVENT_PRO='xmksed_event',$
                                  VALUE= '')
   
   row_base = widget_base(state.w.xmksed_base,$
                          /ROW)

      col1_base = widget_base(row_base,$
                              EVENT_PRO='xmksed_event',$
                              /COLUMN)
      
         box1_base = widget_base(col1_base,$
                                 /COLUMN,$
                                 /FRAME)
         
            label = widget_label(box1_base,$
                                 VALUE='1.  Load Spectra',$
                                 FONT=buttonfont,$
                                 /ALIGN_LEFT)
            
            
            row = widget_base(box1_base,$
                              /ROW,$
                              /BASE_ALIGN_CENTER)
            
               button = widget_button(row,$
                                      FONT=buttonfont,$
                                      VALUE='Path',$
                                      UVALUE='Path Button',$
                                      EVENT_PRO='xmksed_event')
               
               field = coyote_field2(row,$
                                     LABELFONT=buttonfont,$
                                     FIELDFONT=textfont,$
                                     TITLE=':',$
                                     UVALUE='Path Field',$
                                     XSIZE=25,$
                                     EVENT_PRO='xmksed_event',$
                                     /CR_ONLY,$
                                     TEXTID=textid)
               state.w.path_fld = [field,textid]    
               
            row = widget_base(box1_base,$
                              /ROW,$
                              /BASE_ALIGN_CENTER)
            
               input = widget_button(row,$
                                     FONT=buttonfont,$
                                     VALUE='Input Spectrum',$
                                     UVALUE='Input Spectrum',$
                                     EVENT_PRO='xmksed_event')
               
               
               input_fld = coyote_field2(row,$
                                         LABELFONT=buttonfont,$
                                         FIELDFONT=textfont,$
                                         TITLE=':',$
                                         UVALUE='Input Spectrum Field',$
                                         XSIZE=15,$
                                         EVENT_PRO='xmksed_event',$
                                         /CR_ONLY,$
                                         TEXTID=textid)
               state.w.ispectrum_fld = [input_fld,textid]
               
            load = widget_button(box1_base,$
                                 VALUE='Load Spectrum',$
                                 UVALUE='Load Spectrum',$
                                 FONT=buttonfont)

         box2_base = widget_base(col1_base,$
                                 /COLUMN,$
                                 /FRAME)
  
            fixtype_dl = widget_droplist(box2_base,$
                                         font=buttonfont,$
                                         title='2.  Fix Type: ',$
                                         value=['Short','Connect','Long'],$
                                         uvalue='Fix Type')
            
          col2_base = widget_base(row_base,$
                                  /COLUMN)

             label = 'X: 0.000000'
             state.w.message = widget_text(col2_base, $
                                           VALUE=label,$
                                           YSIZE=1)

             state.w.plotwin1 = widget_draw(col2_base,$
                                            XSIZE=state.p.plot1size[0],$
                                            YSIZE=state.p.plot1size[1],$
                                            /TRACKING_EVENTS,$
                                            /BUTTON_EVENTS,$
                                            /MOTION_EVENTS,$
                                         EVENT_PRO='xmksed_plotwinevent1',$
                                            UVALUE='Plot Window 1')
       
             row_base = widget_base(col2_base,$
                                    /ROW)
   
                xmin = coyote_field2(row_base,$
                                     LABELFONT=buttonfont,$
                                     FIELDFONT=textfont,$
                                     TITLE='X Min:',$
                                     UVALUE='X Min',$
                                     XSIZE=12,$
                                     EVENT_PRO='xmksed_minmax',$
                                     /CR_ONLY,$
                                     TEXTID=textid)
                state.w.xmin_fld = [xmin,textid]
                
                xmax = coyote_field2(row_base,$
                                     LABELFONT=buttonfont,$
                                     FIELDFONT=textfont,$
                                     TITLE='X Max:',$
                                     UVALUE='X Max',$
                                     XSIZE=12,$
                                     EVENT_PRO='xmksed_minmax',$
                                     /CR_ONLY,$
                                     TEXTID=textid)
                state.w.xmax_fld = [xmax,textid]
                
                ymin = coyote_field2(row_base,$
                                     LABELFONT=buttonfont,$
                                     FIELDFONT=textfont,$
                                     TITLE='Y Min:',$
                                     UVALUE='Y1 Min',$
                                     XSIZE=12,$
                                     EVENT_PRO='xmksed_minmax',$
                                     /CR_ONLY,$
                                     TEXTID=textid)
                state.w.ymin1_fld = [ymin,textid]
                
                ymax = coyote_field2(row_base,$
                                     LABELFONT=buttonfont,$
                                     FIELDFONT=textfont,$
                                     TITLE='Y Max:',$
                                     UVALUE='Y1 Max',$
                                     XSIZE=12,$
                                     EVENT_PRO='xmksed_minmax',$
                                     /CR_ONLY,$
                                     TEXTID=textid)
                state.w.ymax1_fld = [ymax,textid]

         box3_base = widget_base(col1_base,$
                                 /COLUMN,$
                                 /FRAME)
  
            label = widget_label(box3_base,$
                                 VALUE='5.  Write File',$
                                 FONT=buttonfont,$
                                 /ALIGN_LEFT)
            
;            outformat_bg = cw_bgroup(box3_base,$
;                                     font=buttonfont,$
;                                     ['FITS','Text'],$
;                                     /row,$
;                                     /return_name,$
;                                     /no_release,$
;                                     /nonexclusive,$
;                                     label_left='Output Format:',$
;                                     UVALUE='Output Format',$
;                                     set_VALUE=[1,0])

            oname = coyote_field2(box3_base,$
                                  labelfont=buttonfont,$
                                  fieldfont=textfont,$
                                  title='Object File:',$
                                  event_pro = 'xtellcor_event',$
                                  uvalue='Object File Oname',$
                                  /cr_only,$
                                  xsize=18,$
                                  textID=textid)
            state.w.oname_fld = [oname,textid]

            button = widget_button(box3_base,$
                                   FONT=buttonfont,$
                                   VALUE='Write File',$
                                   UVALUE='Write File')
            

; Get things running.  Center the widget using the Fanning routine.
      
    centertlb,state.w.xmksed_base
      
    widget_control, state.w.xmksed_base, /REALIZE
    
    mkct
    
;  Get plotwin ids
    
    widget_control, state.w.plotwin1, GET_VALUE=x
    state.p.plotwin1_wid = x
    
    window, /free, /pixmap,xsize=state.p.plot1size[0],$
      ysize=state.p.plot1size[1]
    state.p.pixmap1_wid = !d.window

;  Get sizes for things.
    
    widget_geom = widget_info(state.w.xmksed_base, /geometry)
    state.p.buffer[0]=widget_geom.xsize-state.p.plot1size[0]
    state.p.buffer[1]=widget_geom.ysize-state.p.plot1size[1]

; Start the Event Loop. This will be a non-blocking program.
    
    XManager, 'xmksed', $
      state.w.xmksed_base, $
      cleanup = 'xmksed_cleanup',$
      event_handler='xmksed_resize',$
      /NO_BLOCK
    
; Put state variable into the user value of the top level base.

widget_control, state.w.xmksed_base, set_uvalue=state, /no_copy



cont:

end

