pro xpickorder_init,orders,naps,porder,pap

common xpickorder_state,state

state = {pickorder_base:0L,$
         orders:orders,$
         naps:naps,$
         porder:orders[0],$
         pap:1}

end
;
;******************************************************************************
;
; ------------------------------Event Handlers-------------------------------- 
;
;******************************************************************************
;
pro xpickorder_event,event

common xpickorder_state
widget_control, event.id,  GET_UVALUE = uvalue

case uvalue of

    'Pick Ap': state.pap =  fix(event.value)

    'Pick Order': state.porder =  fix(event.value)

    'Accept': widget_control, event.top, /DESTROY
    
endcase

end
;
;******************************************************************************
;
pro xpickorder,orders,naps,group_leader,porder,pap

common xpickorder_state

buttonfont = '-adobe-helvetica-bold-r-normal--14-140-75-75-p-82-iso8859-1'

xpickorder_init,orders,naps,porder,pap

state.pickorder_base = widget_base(GROUP_LEADER=group_leader, $
                                     /COLUMN,$
                                     TITLE='Pick Spectrum')

   row = widget_base(state.pickorder_base,$
                     /ROW)
   
      orders_base = widget_base(row,$
                                /COLUMN,$
                                /BASE_ALIGN_LEFT,$
                                /FRAME)
          
         label = widget_label(orders_base,$
                              FONT=buttonfont,$
                              VALUE='Choose Orders',$
                              /ALIGN_CENTER)
         
         orders_bg = cw_bgroup(orders_base,$
                               FONT=buttonfont,$
                               string(orders,format='(i2.2)'),$
                               XSIZE=100,$
                               YSIZE=200,$
                               /EXCLUSIVE,$
                               /RETURN_NAME,$
                               /NO_RELEASE,$
                               /COLUMN,$
                               SET_VALUE=0,$
                               UVALUE='Pick Order')
         
      aps_base = widget_base(row,$
                             /COLUMN,$
                             /BASE_ALIGN_CENTER,$
                             /FRAME)
      
         label = widget_label(aps_base,$
                              FONT=buttonfont,$
                              VALUE='Choose Apertures',$
                              /ALIGN_CENTER)
         
         aps_bg = cw_bgroup(aps_base,$
                            FONT=buttonfont,$
                            string(indgen(naps)+1,format='(i2.2)'),$
                            XSIZE=100,$
                            YSIZE=200,$
                            /EXCLUSIVE,$
                            /RETURN_NAME,$
                            SET_VALUE=0,$
                            /NO_RELEASE,$
                            /COLUMN,$
                            UVALUE='Pick Ap')
         
   button = widget_button(state.pickorder_base,$
                          VALUE='Accept',$
                          UVALUE='Accept',$
                          FONT=buttonfont)
   
widget_control, state.pickorder_base, /REALIZE
   
; Start the Event Loop. This will be a non-blocking program.

XManager, 'xpickorder', $
  state.pickorder_base

porder = state.porder
pap    = state.pap

end
